import java.net.*;
import java.io.IOException;

class LNP {

  final static String version = "LNP v.1.0";
  final static int BUFSIZE = 64;

  public static void main(String [] args) throws SocketException, UnknownHostException, IOException
  {

    if( args.length == 0 ) throw new IllegalArgumentException("Please provide a hostname as cmdline-parameter!");

    String hostname = args[0];
      
    DatagramSocket udp = new DatagramSocket();

    udp.setBroadcast(true);

    if(!udp.getBroadcast()) System.out.println("No Broadcast available!");

    udp.setSoTimeout(1000);
 
    byte buffer[] = new byte[BUFSIZE];
     
    DatagramPacket packet = new DatagramPacket(buffer, buffer.length);

    packet.setData(String.format("%s\n%s\n", version, hostname).getBytes());

    packet.setAddress(InetAddress.getByName("255.255.255.255"));
    packet.setPort(2019);

    udp.send(packet);

    packet.setData(buffer);

    try {
      udp.receive(packet);
      String data = new String(packet.getData());
      System.out.print(data.substring(data.indexOf('\n')+1));
    } catch(SocketTimeoutException e) {
      System.out.println("No host responded to that name.");
    }
  }

}

