#ifndef _LNP_H_
#define _LNP_H_ _LNP_H_

#define _POSIX_C_SOURCE 200112L

#define LNP_VERSION "LNP v.1.0"

#include <error.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <limits.h>
#include <ifaddrs.h>
#include <signal.h>

#define BUFSIZE HOST_NAME_MAX+1 
/* 
 * the actually defined version
 * caution: vlen cannot be set dynamically
 * this must be attended when changing version
 */
static const char *version = LNP_VERSION;
static const int vlen = 9;
/* 
 * format check, the protocol has two lines
 * of character data, both end with a single line-feed
 * return -1 if format is violated
 */
int checkProtocolFormat(char*, int);
/*
 * if the protocol versions do not match, 
 * or the buffer is shorter than version number
 * -1 is returned
 */
int checkProtocolVersion(char*, int);
/*
 * formats the request message,
 * if return value is greater or equal to buffers size
 * then the buffer was truncated and thus not null-terminated
 */
int makeMessage(char*, int, char*);

#endif

