// lnp.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

void printWSAErrorMsg(char *reason)
{
	wchar_t *errstr = NULL;
	FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 
			   NULL, WSAGetLastError(),
			   MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			   (LPWSTR)&errstr, 0, NULL);
	fprintf(stderr, "%s: %s\n", reason, errstr);
	LocalFree(errstr);
}


int main(int argc, char* argv[])
{

	WSADATA wsaData;

	int errcode = 0;
	if( errcode = WSAStartup(MAKEWORD(2,2), &wsaData) ) 
		printf("Fehler bei der Initialisierung von winsock2: %d\r\n", errcode);

	/* check hostname argument */
	if( argc < 2 )
	{
		fprintf(stderr, "Aufruf: %s <hostname>", argv[0]);
		exit(1);
	}

	/* initialize udp socket */
	int udp;
	if( (udp = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1) printWSAErrorMsg("socket");

	/* enable broadcast socket */
	int opt = 1;
	if( setsockopt(udp, SOL_SOCKET, SO_BROADCAST, (const char *) &opt, sizeof(opt)) == -1) printWSAErrorMsg("set broadcast socket");

	opt = 1000;
	if( setsockopt(udp, SOL_SOCKET, SO_RCVTIMEO, (const char *) &opt, sizeof(opt)) == -1) printWSAErrorMsg("set socket timeout");
	/* define destination broadcast address and port */
	struct sockaddr_in inaddr;
	inaddr.sin_port = htons(2019);
	inaddr.sin_family = AF_INET;
	inaddr.sin_addr.s_addr = INADDR_BROADCAST;

	/* allocate protocol/packet buffer */
	char buffer[BUFSIZE+vlen+2];
	int anz, addrlen;

	/* prepare address for answer/reply */
	struct sockaddr_in sender = {0};
	addrlen = sizeof(sender);

	/* format request message udp packet */
	int len = makeMessage(buffer, sizeof(buffer), argv[1]);
	if( len >= sizeof(buffer) )
	{
		fprintf(stderr, "buffer too small, truncated");
		len = sizeof(buffer);
	}

	/* send request message/packet */
	if(sendto(udp, buffer, len, 0, (const struct sockaddr*) &inaddr, sizeof(inaddr)) == -1) printWSAErrorMsg("sendto");

	/* receive a possible answer/reply message */
	if( (anz = recvfrom(udp, buffer, sizeof(buffer), 0, (struct sockaddr*) &sender, &addrlen)) == -1) 
	{
		if( WSAGetLastError() == WSAETIMEDOUT )
		{
			fprintf(stderr, "No host responded to that name.\n");
			exit(1);
		}
		else printWSAErrorMsg("recvfrom");	
	}

	/* null-terminate buffer (optional) */
	if( anz < sizeof(buffer)-1 ) buffer[anz] = '\0';
	else buffer[sizeof(buffer)-1] = '\0';

	/* check reply message format */
	if( checkProtocolFormat(buffer, sizeof(buffer)) ) fprintf(stderr, "packet format violation");
	/* check reply message version */
	if( checkProtocolVersion(buffer, sizeof(buffer)) ) fprintf(stderr, "%s version mismatch: %s", version, buffer);

	/* print the ip-address -> only correct, if version-length identical */
	printf("%s", buffer+vlen+1);

	/* clean up and exit */
	shutdown(udp, SD_BOTH);
	WSACleanup();
	return 0;
}

