#pragma once

#ifdef LIBLNP_EXPORTS
#define LNPLIBRARY_API __declspec(dllexport)
#else
#define LNPLIBRARY_API __declspec(dllimport)
#endif

#define _POSIX_C_SOURCE 200112L

#define LNP_VERSION "LNP v.1.0"

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <signal.h>

#define BUFSIZE 65 //HOST_NAME_MAX == 64 +1 
/* 
 * the actually defined version
 * caution: vlen cannot be set dynamically
 * this must be attended when changing version
 */
static const char *version = LNP_VERSION;
static const int vlen = 9;
/* 
 * format check, the protocol has two lines
 * of character data, both end with a single line-feed
 * return -1 if format is violated
 */
extern "C" LNPLIBRARY_API int checkProtocolFormat(char*, unsigned);
/*
 * if the protocol versions do not match, 
 * or the buffer is shorter than version number
 * -1 is returned
 */
extern "C" LNPLIBRARY_API int checkProtocolVersion(char*, int);
/*
 * formats the request message,
 * if return value is greater or equal to buffers size
 * then the buffer was truncated and thus not null-terminated
 */
extern "C" LNPLIBRARY_API int makeMessage(char*, int, char*);


